###### R podest (kovariance a korelace)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/data1.xlsx")
# data <- read_excel("E:/R/data1.xlsx") # cesta k datm na Vaich flekch
data <- as.data.frame(data) # vytvome ze vstupnch dat datovou tabulku


####Kovariance####

# R m pro kovariance vestavnou funkci cov() a lze s n vypotat pedevm hodnotu 
# kovariance dvou promnnch:

cov(data$Ca1, data$Mg1) # kovariance Ca1 a Mg1

# Lze ale tak vypotat kovarian matici, nejprve si ale vyberme z dat pomrov
# promnn a vytvome novou datovou tabulku:

data2 <- data.frame(data$NH4N1, data$NO3N1, data$TP1, data$Mg1, data$Ca1, data$c1, data$pH1)

cov(data2) # vypot kovarian matici

# Pokud nkoho pekvapilo, e na diagonle nejsou jedniky nebo nuly, tak jen 
# pipomnme, e na diagonle jsou rozptyly dan promnn - viz vzorec kovariance.



####Korelace####

# Korelace m vestavn pkaz cor() a jeho pouit je identick 
# s kovarianc, jen mme monost volit typ korelace v parametru method a 
# na vbr mme pearson, spearman a kendall

cormat1 <- cor(data2, method="pearson") # pro Pearsonv k.k.
cormat2 <- cor(data2, method="spearman") # pro Poadov Spearmanv k.k.
cormat3 <- cor(data2, method="kendall") # pro Kendall Tau k.k.

# V zkladu bohuel nelze koeficienty testovat, nicmn lze pout package
# corrplot

install.packages("corrplot")

library(corrplot)

# Pkaz na vpoet matice statistick vznamnosti korelanch koeficient
# je cor.mtest()

cor.mtest(data2)

p.data2 <- cor.mtest(data2) # vsledk si ulome, pa ho za chvli budeme potebovat

# Vizualizace souvislosti je mon mnoha zpsoby nejjednodu je xy graf

plot(data2$data.Ca1, data2$data.Mg1)

# irok spektrum monost vizualizace korelan matice pak nabz 
# ve nainstalovan package corrplot

# Pkaz je corrplot() a m velk mnostv atrubut a parametr

corrplot(cormat1, method = "circle")

# Tohle je nejjednodu monost - barva a velikost koleet ukazuj velikost 
# k.k., lze do nj ale i vloit vsledek testu statistick vznamnosti:

corrplot(cormat1, method = "circle", p.mat = p.data2$p, sig.level = .05)

# nebo si lze prohrt:

corrplot(cormat1, method = "shade", type = "upper" , p.mat = p.data2$p, 
         sig.level = c(.001, .01, .05), pch.cex = .9,
         insig = "label_sig", pch.col = "white")

# kompletn pehled je tady: https://cran.r-project.org/web/packages/corrplot/vignettes/corrplot-intro.html



####Parciln korelace####

# Parciln korelan koeficienty lze zskat pkazem pcor 
# z package ppcor:

install.packages("ppcor")

library(ppcor)

pcor(data2, method = "pearson")

# Vsledkem pkazu jsou matice parcilnch k.k. (odeten je vdy vliv 
# vech ostatnch promnnch - $estimate) a matice statistick vznamnosti
# k.k. ($p.value)



####Mnohonsobn korelace####

#  V R nen dn pm nstroj pro vpoet mnohonsobnho korelanho 
# koeficientu. Bu si jej vypotte run z korelan matice - funkce pro
# vpoet koeficientu determinance matice je det(), nebo se d R zjistit 
# z regres, na kter se podvme pt.